# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class VpcIpv4CidrBlockAssociation(pulumi.CustomResource):
    """
    Provides a resource to associate additional IPv4 CIDR blocks with a VPC.
    
    When a VPC is created, a primary IPv4 CIDR block for the VPC must be specified.
    The `aws_vpc_ipv4_cidr_block_association` resource allows further IPv4 CIDR blocks to be added to the VPC.
    """
    def __init__(__self__, __name__, __opts__=None, cidr_block=None, vpc_id=None):
        """Create a VpcIpv4CidrBlockAssociation resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not cidr_block:
            raise TypeError('Missing required property cidr_block')
        elif not isinstance(cidr_block, basestring):
            raise TypeError('Expected property cidr_block to be a basestring')
        __self__.cidr_block = cidr_block
        """
        The additional IPv4 CIDR block to associate with the VPC.
        """
        __props__['cidrBlock'] = cidr_block

        if not vpc_id:
            raise TypeError('Missing required property vpc_id')
        elif not isinstance(vpc_id, basestring):
            raise TypeError('Expected property vpc_id to be a basestring')
        __self__.vpc_id = vpc_id
        """
        The ID of the VPC to make the association with.
        """
        __props__['vpcId'] = vpc_id

        super(VpcIpv4CidrBlockAssociation, __self__).__init__(
            'aws:ec2/vpcIpv4CidrBlockAssociation:VpcIpv4CidrBlockAssociation',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'cidrBlock' in outs:
            self.cidr_block = outs['cidrBlock']
        if 'vpcId' in outs:
            self.vpc_id = outs['vpcId']
