# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class GetPolicyDocumentResult(object):
    """
    A collection of values returned by getPolicyDocument.
    """
    def __init__(__self__, json=None, id=None):
        if json and not isinstance(json, basestring):
            raise TypeError('Expected argument json to be a basestring')
        __self__.json = json
        """
        The above arguments serialized as a standard JSON policy document.
        """
        if id and not isinstance(id, basestring):
            raise TypeError('Expected argument id to be a basestring')
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """

def get_policy_document(override_json=None, policy_id=None, source_json=None, statements=None):
    """
    Generates an IAM policy document in JSON format.
    
    This is a data source which can be used to construct a JSON representation of
    an IAM policy document, for use with resources which expect policy documents,
    such as the `aws_iam_policy` resource.
    
    ```hcl
    data "aws_iam_policy_document" "example" {
      statement {
        sid = "1"
    
        actions = [
          "s3:ListAllMyBuckets",
          "s3:GetBucketLocation",
        ]
    
        resources = [
          "arn:aws:s3:::*",
        ]
      }
    
      statement {
        actions = [
          "s3:ListBucket",
        ]
    
        resources = [
          "arn:aws:s3:::${var.s3_bucket_name}",
        ]
    
        condition {
          test     = "StringLike"
          variable = "s3:prefix"
    
          values = [
            "",
            "home/",
            "home/&{aws:username}/",
          ]
        }
      }
    
      statement {
        actions = [
          "s3:*",
        ]
    
        resources = [
          "arn:aws:s3:::${var.s3_bucket_name}/home/&{aws:username}",
          "arn:aws:s3:::${var.s3_bucket_name}/home/&{aws:username}/*",
        ]
      }
    }
    
    resource "aws_iam_policy" "example" {
      name   = "example_policy"
      path   = "/"
      policy = "${data.aws_iam_policy_document.example.json}"
    }
    ```
    
    Using this data source to generate policy documents is *optional*. It is also
    valid to use literal JSON strings within your configuration, or to use the
    `file` interpolation function to read a raw JSON policy document from a file.
    """
    __args__ = dict()

    __args__['overrideJson'] = override_json
    __args__['policyId'] = policy_id
    __args__['sourceJson'] = source_json
    __args__['statements'] = statements
    __ret__ = pulumi.runtime.invoke('aws:iam/getPolicyDocument:getPolicyDocument', __args__)

    return GetPolicyDocumentResult(
        json=__ret__.get('json'),
        id=__ret__.get('id'))
