# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class Alias(pulumi.CustomResource):
    """
    Provides an alias for a KMS customer master key. AWS Console enforces 1-to-1 mapping between aliases & keys,
    but API (hence Terraform too) allows you to create as many aliases as
    the [account limits](http://docs.aws.amazon.com/kms/latest/developerguide/limits.html) allow you.
    """
    def __init__(__self__, __name__, __opts__=None, name=None, name_prefix=None, target_key_id=None):
        """Create a Alias resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        The display name of the alias. The name must start with the word "alias" followed by a forward slash (alias/)
        """
        __props__['name'] = name

        if name_prefix and not isinstance(name_prefix, basestring):
            raise TypeError('Expected property name_prefix to be a basestring')
        __self__.name_prefix = name_prefix
        """
        Creates an unique alias beginning with the specified prefix.
        The name must start with the word "alias" followed by a forward slash (alias/).  Conflicts with `name`.
        """
        __props__['namePrefix'] = name_prefix

        if not target_key_id:
            raise TypeError('Missing required property target_key_id')
        elif not isinstance(target_key_id, basestring):
            raise TypeError('Expected property target_key_id to be a basestring')
        __self__.target_key_id = target_key_id
        """
        Identifier for the key for which the alias is for, can be either an ARN or key_id.
        """
        __props__['targetKeyId'] = target_key_id

        __self__.arn = pulumi.runtime.UNKNOWN
        """
        The Amazon Resource Name (ARN) of the key alias.
        """
        __self__.target_key_arn = pulumi.runtime.UNKNOWN
        """
        The Amazon Resource Name (ARN) of the target key identifier.
        """

        super(Alias, __self__).__init__(
            'aws:kms/alias:Alias',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'arn' in outs:
            self.arn = outs['arn']
        if 'name' in outs:
            self.name = outs['name']
        if 'namePrefix' in outs:
            self.name_prefix = outs['namePrefix']
        if 'targetKeyArn' in outs:
            self.target_key_arn = outs['targetKeyArn']
        if 'targetKeyId' in outs:
            self.target_key_id = outs['targetKeyId']
